uk.ac.starlink.table.formats

## Class AsciiTableWriter

- java.lang.Object
- - uk.ac.starlink.table.formats.DocumentedStreamStarTableWriter
  - - uk.ac.starlink.table.formats.AbstractTextTableWriter
    - - uk.ac.starlink.table.formats.AsciiTableWriter

- All Implemented Interfaces:
    Documented, DocumentedIOHandler, StarTableWriter

      public class AsciiTableWriter
      extends AbstractTextTableWriter

  A StarTableWriter which outputs text to a simple format machine-readable text file. This format is suitable for reading using `AsciiStarTable` and `AsciiTableBuilder`.
  Since:
    29 Mar 2004

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsciiTableWriter()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `docIncludesExample()` Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
    `protected java.lang.String` | `formatValue(java.lang.Object val, ValueInfo vinfo, int width)` Formats a data value for output.
    `java.lang.String` | `getFormatName()` Returns "ascii".
    `java.lang.String` | `getXmlDescription()` Returns user-directed documentation in XML format.
    `protected void` | `printColumnHeads(java.io.OutputStream strm, int[] colwidths, ColumnInfo[] cinfos)` Outputs headings for the table columns.
    `protected void` | `printLine(java.io.OutputStream strm, int[] colwidths, java.lang.String[] data)` Outputs a line of table data.
    `protected void` | `printParam(java.io.OutputStream strm, java.lang.String name, java.lang.String value, java.lang.Class<?> clazz)` Outputs a parameter and its value.
    `protected void` | `printSeparator(java.io.OutputStream strm, int[] colwidths)` Outputs a decorative separator line, of the sort you might find between the column headings and the table data.

    - ### Methods inherited from class uk.ac.starlink.table.formats.AbstractTextTableWriter

      `getBytes, getMaximumParameterLength, getMaxWidth, getMimeType, getMinNameWidth, getSampledRows, getWriteParameters, setMaximumParameterLength, setMaxWidth, setSampledRows, setWriteParameters, writeStarTable`

    - ### Methods inherited from class uk.ac.starlink.table.formats.DocumentedStreamStarTableWriter

      `getExtensions, looksLikeFile, writeStarTable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface uk.ac.starlink.table.formats.DocumentedIOHandler

      `matchesExtension, readText, toLink`

- - ### Constructor Detail

    - #### AsciiTableWriter

          public AsciiTableWriter()

  - ### Method Detail

    - #### formatValue

          protected java.lang.String formatValue(java.lang.Object val,
                                                 ValueInfo vinfo,
                                                 int width)

      Description copied from class: `AbstractTextTableWriter`
      Formats a data value for output.
      Specified by:
        `formatValue` in class `AbstractTextTableWriter`
      Parameters:
        `val` - the value
        `vinfo` - the metadata object describing `val`'s type
        `width` - maximum preferred width into which the value should be formatted
      Returns:
        formatted string meaning `value`, preferably no longer than `width` characters

    - #### getFormatName

          public java.lang.String getFormatName()

      Returns "ascii".
      Specified by:
        `getFormatName` in interface `StarTableWriter`
      Overrides:
        `getFormatName` in class `AbstractTextTableWriter`
      Returns:
        output format

    - #### docIncludesExample

          public boolean docIncludesExample()

      Description copied from interface: `DocumentedIOHandler`
      Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.
      Returns:
        true if the user documentation would benefit from the addition of an example serialization

    - #### getXmlDescription

          public java.lang.String getXmlDescription()

      Description copied from interface: `Documented`
      Returns user-directed documentation in XML format.

      The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

      Returns:
        XML description of this object

    - #### printSeparator

          protected void printSeparator(java.io.OutputStream strm,
                                        int[] colwidths)

      Description copied from class: `AbstractTextTableWriter`
      Outputs a decorative separator line, of the sort you might find between the column headings and the table data.
      Specified by:
        `printSeparator` in class `AbstractTextTableWriter`
      Parameters:
        `strm` - stream to write into
        `colwidths` - column widths in characters

    - #### printLine

          protected void printLine(java.io.OutputStream strm,
                                   int[] colwidths,
                                   java.lang.String[] data)
                            throws java.io.IOException

      Description copied from class: `AbstractTextTableWriter`
      Outputs a line of table data.
      Specified by:
        `printLine` in class `AbstractTextTableWriter`
      Parameters:
        `strm` - stream to write into
        `colwidths` - column widths in characters
        `data` - array of strings to be output, one per column
      Throws:
        `java.io.IOException`

    - #### printColumnHeads

          protected void printColumnHeads(java.io.OutputStream strm,
                                          int[] colwidths,
                                          ColumnInfo[] cinfos)
                                   throws java.io.IOException

      Description copied from class: `AbstractTextTableWriter`
      Outputs headings for the table columns.
      Specified by:
        `printColumnHeads` in class `AbstractTextTableWriter`
      Parameters:
        `strm` - stream to write into
        `colwidths` - column widths in characters
        `cinfos` - array of column headings
      Throws:
        `java.io.IOException`

    - #### printParam

          protected void printParam(java.io.OutputStream strm,
                                    java.lang.String name,
                                    java.lang.String value,
                                    java.lang.Class<?> clazz)
                             throws java.io.IOException

      Description copied from class: `AbstractTextTableWriter`
      Outputs a parameter and its value.
      Specified by:
        `printParam` in class `AbstractTextTableWriter`
      Parameters:
        `strm` - stream to write into
        `name` - parameter name
        `value` - formatted parameter value
        `clazz` - type of value
      Throws:
        `java.io.IOException`